/*
This file is part of the SunVox library.
Copyright (C) 2007 - 2023 Alexander Zolotov <nightradio@gmail.com>
WarmPlace.ru

MINIFIED VERSION
(not yet intended to be modified)

License: (MIT)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to
deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
IN THE SOFTWARE.
*/

   
#include "sundog.h"
#include "psynth_strings.h"
    
const char* ps_get_string( ps_string str_id ) { const char* str = NULL; const char* lang = slocale_get_lang(); while( 1 )
 { if( smem_strstr( lang, "ru_" ) ) {
 switch( str_id ) {
 case STR_PS_OFF_ON: str = "выкл;вкл"; break;
 case STR_PS_STEREO_MONO: str = "стерео;моно"; break; case STR_PS_MONO_STEREO: str = "моно;стерео"; break; case STR_PS_GEN_WAVE_TYPES: str = "треугольная;пила;прямоугольная;шум (сэмплер);нарисованная;sin;hsin;asin;psin"; break; case STR_PS_GEN2_WAVE_TYPES: str = "треугольная;пила;прямоугольная;шум (сэмплер);нарисованная;sin;hsin;asin;нарисован.сплайн;шум.сплайн (сэмплер);белый шум;розовый шум;красный шум;синий шум;фиолетовый шум;серый шум;гармоники"; break; case STR_PS_GEN2_FILTER_TYPES: str = "выкл;нижних 12дБ;верхних 12дБ;полосовой 12дБ;режекторный 12дБ;нижних 24дБ;верхних 24дБ;полосовой 24дБ;режекторный 24дБ"; break; case STR_PS_GEN2_F_ENVELOPE_TYPES: str = "выкл;без удержания;с удержанием"; break; case STR_PS_GEN2_OSC2_MODES: str = "сложение;вычитание;умножение;min;max;побитовое И (AND);побитовое искл.ИЛИ (XOR)"; break; case STR_PS_FILTER_TYPES: str = "нижних;верхних;полосовой;режекторный"; break; case STR_PS_DELAY_UNITS: str = "сек/16384;мс;Гц;тик;строка;строка/2;строка/3;сек/44100;сек/48000;отсчет"; break; case STR_PS_ECHO_DELAY_UNITS: str = "сек/256;мс;Гц;тик;строка;строка/2;строка/3"; break; case STR_PS_ECHO_FILTERS: str = "выкл;нижних 6дБ;верхних 6дБ"; break; case STR_PS_FILTER_LFO_WAVEFORM_TYPES: str = "sin;пила;пила2;прямоугольная;случайная"; break; case STR_PS_FILTER_LFO_FREQ_UNITS: str = "Гц*0.02;мс;Гц;тик;строка;строка/2;строка/3"; break; case STR_PS_FILTER_ROLLOFF_VALS: str = "12дБ;24дБ;36дБ;48дБ"; break; case STR_PS_FILTER2_TYPES: str = "нижних;верхних;полосовой;полосовой с постоян.пиком;режекторный;фазовый;пиковый;полка в низких;полка в высоких;нижних 6дБ;верхних 6дБ"; break; case STR_PS_FILTER2_MODES: str = "стерео;моно;стерео + сглаживание;моно + сглаживание"; break; case STR_PS_FLANGER_LFO_FREQ_UNITS: str = "Гц*0.05;мс;Гц;тик;строка;строка/2;строка/3"; break; case STR_PS_KICKER_WAVE_TYPES: str = "треугольная;прямоугольная;sin"; break; case STR_PS_LFO_TYPES: str = "амплитуда;панорама"; break; case STR_PS_LFO_WAVEFORM_TYPES: str = "sin;прямоугольная;sin2;пила;пила2;случайная;треугольная;случайная плавная"; break; case STR_PS_LFO_FREQ_UNITS: str = "Гц/64;мс;Гц;тик;строка;строка/2;строка/3"; break; case STR_PS_LFO_SMOOTH_TRANSITIONS: str = "выкл;внутри волны"; break; case STR_PS_MODULATION_TYPES: str = "амплитудная;фазовая;фазовая (абсолютн.)"; break; case STR_PS_MODULATION_TYPES2: str = "фазовая;частотная;амплитудная (умножение);сложение;вычитание;min;max;побитовое И (AND);побитовое искл.ИЛИ (XOR);фазовая+"; break; case STR_PS_INTERP_TYPES:  case STR_PS_SAMPLE_INTERP_TYPES: str = "выкл;линейная;сплайн"; break; case STR_PS_ENVELOPE_INTERP_TYPES: str = "выкл;линейная"; break; case STR_PS_HARMONIC_TYPES: str = "hsin;прямоугольн.;org1;org2;org3;org4;sin;случайная;треугольн.1;треугольн.2;обертоны1;обертоны2;обертоны3;обертоны4;обертоны1+;обертоны2+;обертоны3+;обертоны4+;металл"; break;
 case STR_PS_VOWEL_TYPES: str = "а;е;и;о;у"; break; case STR_PS_VOICE_TYPES: str = "сопрано;альт;тенор;бас"; break;
 case STR_PS_LOOP_MODES: str = "нормальный;зеркальный"; break;
 case STR_PS_LOOP_LENGTH_UNITS: str = "строка/128;строка;строка/2;строка/3;тик;мс;Гц"; break; case STR_PS_LOOP_NOTEON_MODES: str = "перезапуск;перезапуск текущей итерации"; break; case STR_PS_PITCH2CTL_MODES: str = "частота (Гц);высота тона"; break; case STR_PS_PITCH2CTL_NOTEOFF_ACTION: str = "ничего не делать;тон вниз;тон вверх"; break;
 case STR_PS_VELOCITY2CTL_NOTEOFF_ACTION: str = "ничего не делать;динамика вниз;динамика вверх"; break; case STR_PS_METAMODULE_PLAY_PAT_MODES: str = "выкл;вкл (с повтором);вкл (один раз);вкл (повтор без выкл);вкл (один раз без выкл)"; break; case STR_PS_COMPRESSOR_MODES: str = "пиковый;RMS;пиковый без задержки"; break;
 case STR_PS_DISTORTION_TYPES: str = "обрезание;foldback;foldback2;foldback3;переполнение;переполнение2;насыщение+foldback;насыщение+foldback(sin);насыщение3;насыщение4;насыщение5"; break; case STR_PS_STOP_START: str = "стоп;старт"; break; case STR_PS_ADSR_CURVE_TYPES: str = "линейная;exp1;exp2;-exp1;-exp2;sin;прямоугольная;прямоугольная+сглаживание;2bit;3bit;4bit;5bit"; break; case STR_PS_ADSR_MODES: str = "генератор;амп.модулятор моно;амп.модулятор стерео"; break; case STR_PS_ADSR_NOTEON_ACTIONS: str = "ничего не делать;старт на первой ноте;старт"; break; case STR_PS_ADSR_NOTEOFF_ACTIONS: str = "ничего не делать;стоп на последней ноте;стоп"; break;
 case STR_PS_ADSR_SMOOTH_TRANSITIONS: str = "выкл;рестарт и изм.громкости;рестарт (еще плавнее) и изм.громкости;изм.громкости"; break; case STR_PS_ADSR_OFF_ON_REPEAT: str = "выкл;вкл;повтор"; break;
 case STR_PS_NOTEON_MODES: str = "-;при смене высоты тона"; break; case STR_PS_NOTEOFF_MODES: str = "-;на мин.высоте тона;на макс.высоте тона"; break; case STR_PS_PD_ALGS: str = "быстрый (пересечение нуля);автокорреляция;кепстр"; break; case STR_PS_PITCHSHIFTER_PLAYORIG_MODES: str = "выкл;плавн.переход;быстр.переход"; break; case STR_PS_CAPTURE_MODES: str = "выкл;однократно;постоянно"; break;
 case STR_PS_FM2_WAVE_TYPES: str = "пользовательская;треугольная;треугольная^3;пила;пила^3;прямоугольная;sin;hsin;asin;sin^3"; break; case STR_PS_SIN_Q_MODES: str = "авто;низкое;среднее;высокое"; break;
 case STR_PS_CH: str = "кан."; break; case STR_PS_STEREO: str = "стерео"; break; case STR_PS_MONO: str = "моно"; break; case STR_PS_HZ: str = "Гц"; break; case STR_PS_HZ1000: str = "Гц/1000"; break; case STR_PS_MS: str = "мс"; break; case STR_PS_LEVELS: str = "уров."; break; case STR_PS_BIT: str = "бит"; break;
 case STR_PS_LINE128: str = "строка/128"; break;
 case STR_PS_SEMITONE: str = "полутон"; break; case STR_PS_SEMITONE10: str = "полутон/10"; break; case STR_PS_SEMITONE64: str = "полутон/64"; break; case STR_PS_SEC: str = "сек"; break;
 case STR_PS_SEC256: str = "сек/256"; break;
 case STR_PS_DELAY_OFFSET15: str = "задержка/32768"; break;  case STR_PS_SMOOTH: str = "Сглаж."; break; case STR_PS_VOLUME: str = "Громкость"; break;
 case STR_PS_VOLUME_L: str = "Громк.лев.канала"; break;
 case STR_PS_VOLUME_R: str = "Громк.прав.канала"; break; case STR_PS_FINE_VOLUME: str = "Точная громкость"; break; case STR_PS_WAVEFORM_TYPE: str = "Форма волны"; break; case STR_PS_PANNING: str = "Панорама"; break;
 case STR_PS_BALANCE: str = "Баланс"; break;
 case STR_PS_ATTACK: str = "Атака"; break; case STR_PS_DECAY: str = "Спад"; break; case STR_PS_RELEASE: str = "Затухание"; break; case STR_PS_POLYPHONY: str = "Полифония"; break; case STR_PS_MODE: str = "Режим"; break;
 case STR_PS_SUSTAIN: str = "Удержание"; break; case STR_PS_SUSTAIN_PEDAL: str = "Педаль сустейн"; break; case STR_PS_SUSTAIN_LEVEL: str = "Уровень поддержки"; break;
 case STR_PS_FREQ_MODULATION: str = "Част.модуляция по входу"; break;
 case STR_PS_DUTY_CYCLE: str = "Коэф.заполнения"; break; case STR_PS_DRAW_THIS_WAVEFORM: str = "Вы можете рисовать свою форму волны"; break;
 case STR_PS_CHANNELS: str = "Каналы"; break; case STR_PS_CHANNELS_NUM: str = "Кол-во каналов"; break; case STR_PS_BASE: str = "База"; break; case STR_PS_EXP_ENVELOPE: str = "Экспоненц.огибающая"; break;
 case STR_PS_FREQ: str = "Частота"; break; case STR_PS_FREQUENCY: str = "Частота"; break; case STR_PS_FREQ_FINETUNE: str = "Подстройка частоты"; break; case STR_PS_OSC2_PITCH: str = "Осц2"; break;
 case STR_PS_OSC2_VOL: str = "Осц2 громкость"; break; case STR_PS_OSC2_MODE: str = "Осц2 режим"; break;
 case STR_PS_OSC2_PHASE: str = "Осц2 фаза"; break;
 case STR_PS_FILTER: str = "Фильтр"; break; case STR_PS_F_FREQ: str = "Ф.частота"; break; case STR_PS_F_RESONANCE: str = "Ф.резонанс"; break; case STR_PS_F_EXP_FREQ: str = "Ф.экспоненц.частота"; break;
 case STR_PS_F_ATTACK: str = "Ф.атака"; break; case STR_PS_F_RELEASE: str = "Ф.затухание"; break; case STR_PS_F_ENVELOPE: str = "Ф.огибающая"; break; case STR_PS_NOISE: str = "Шум"; break; case STR_PS_TYPE: str = "Тип"; break; case STR_PS_TRANSPOSE: str = "Транспозиция"; break; case STR_PS_QUANTIZATION: str = "Квантование"; break;
 case STR_PS_GAIN: str = "Усиление"; break; case STR_PS_VELOCITY_INFLUENCE: str = "Влияние динамики"; break; case STR_PS_VALUE: str = "Значение"; break; case STR_PS_CURVE: str = "Кривая"; break; case STR_PS_CURVE_MULTICTL: str = "X = исходное значение; Y = значение на выходе"; break; case STR_PS_SEND_VALUE_TO: str = "Кому посылаем:"; break; case STR_PS_DC_OFFSET: str = "DC смещение"; break; case STR_PS_BIPOLAR_DC_OFFSET: str = "Биполярное DC смещение"; break;
 case STR_PS_INVERSE: str = "Инверсия"; break; case STR_PS_STEREO_WIDTH: str = "Ширина стерео"; break; case STR_PS_ABSOLUTE: str = "Абсолютное знач."; break; case STR_PS_DRY: str = "Оригинал"; break; case STR_PS_WET: str = "Обработка"; break; case STR_PS_FEEDBACK: str = "Обр.связь"; break; case STR_PS_RESPONSE: str = "Отклик"; break;
 case STR_PS_DELAY: str = "Задержка"; break; case STR_PS_DELAY_L: str = "Задержка лев.канала"; break; case STR_PS_DELAY_R: str = "Задержка прав.канала"; break; case STR_PS_DELAY_UNIT: str = "Единица задержки"; break; case STR_PS_DELAY_MUL: str = "Множитель задержки"; break; case STR_PS_R_CHANNEL_OFFSET: str = "Смещение прав.канала"; break; case STR_PS_LOW: str = "Низкие"; break; case STR_PS_MIDDLE: str = "Средние"; break; case STR_PS_HIGH: str = "Высокие"; break; case STR_PS_RESONANCE: str = "Резонанс"; break; case STR_PS_MIX: str = "Микс"; break; case STR_PS_BPM: str = "BPM (ударов в минуту)"; break;
 case STR_PS_TPL: str = "TPL (тиков в строке)"; break;
 case STR_PS_USER_DEFINED: str = "Пользовательский"; break; case STR_PS_USER_DEFINED_CONTROLLERS: str = "Контроллеры, назнач. пользователем"; break; case STR_PS_NUMBER_OF_USER_DEFINED_CTLS: str = "Кол-во контроллеров"; break; case STR_PS_INPUT_MODULE: str = "Входной модуль"; break; case STR_PS_PLAY_PATTERNS: str = "Играть паттерны"; break;
 case STR_PS_CONTROLLER: str = "Контроллер:"; break; case STR_PS_LINK_TO: str = "Привязан к:"; break; case STR_PS_CONTROLLER_NAME: str = "Имя контроллера"; break; case STR_PS_ARPEGGIATOR: str = "Арпеджиатор (базовая нота - C5)"; break; case STR_PS_APPLY_VELOCITY_TO_PROJECT: str = "Применять динамику (velocity) к проекту"; break;
 case STR_PS_EVT_OUT: str = "События на выходе"; break; case STR_PS_RECEIVE_NOTES_FROM_KBD: str = "Принимать ноты с клавиатуры"; break; case STR_PS_DONT_RECEIVE_NOTES_FROM_KBD: str = "Не принимать ноты с клавиатуры"; break;
 case STR_PS_WARNING_MODULE_CANT_RECEIVE_SOUND: str = "не подходит для приема звука"; break; case STR_PS_WARNING_MODULE_INPUT_CONNECTIONS: str = "не должен иметь входящие подключения"; break; case STR_PS_WARNING_MODULE_NONSTANDARD_INPUT: str = "нестандартный тип входа; попробуйте другой модуль"; break; case STR_PS_AMPLITUDE: str = "Амплитуда"; break; case STR_PS_SIDE_CHAIN: str = "Сайдчейн"; break; case STR_PS_SIDE_CHAIN_INPUT: str = "Вход сайдчейн"; break; case STR_PS_NONE: str = "нет"; break; case STR_PS_THRESHOLD: str = "Порог"; break; case STR_PS_SLOPE: str = "Наклон"; break;
 case STR_PS_POWER: str = "Мощность"; break; case STR_PS_BIT_DEPTH: str = "Разрядность"; break; case STR_PS_DRUMSYNTH_DESC: str = "C,c,D,d - бочка (bass drum)\nE,F,f - хай-хэт (hi-hat)\nG,g,A,a,B - малый барабан (snare drum)"; break; case STR_PS_BASS_VOLUME: str = "Бочка.громкость"; break; case STR_PS_BASS_POWER: str = "Бочка.мощность"; break; case STR_PS_BASS_TONE: str = "Бочка.тон"; break; case STR_PS_BASS_LENGTH: str = "Бочка.длина"; break; case STR_PS_BASS_PAN: str = "Бочка.панорама"; break; case STR_PS_HIHAT_VOLUME: str = "Хэт.громкость"; break;
 case STR_PS_HIHAT_LENGTH: str = "Хэт.длина"; break;
 case STR_PS_HIHAT_PAN: str = "Хэт.панорама"; break; case STR_PS_SNARE_VOLUME: str = "Малый.громкость"; break; case STR_PS_SNARE_TONE: str = "Малый.тон"; break;
 case STR_PS_SNARE_LENGTH: str = "Малый.длина"; break; case STR_PS_SNARE_PAN: str = "Малый.панорама"; break; case STR_PS_IMPULSE: str = "Импульс"; break;
 case STR_PS_LFO_FREQ: str = "LFO.частота"; break; case STR_PS_LFO_AMP: str = "LFO.амплитуда"; break; case STR_PS_LFO_WAVEFORM: str = "LFO.форма волны"; break; case STR_PS_SET_LFO_PHASE: str = "Установ.фазу LFO"; break; case STR_PS_LFO_FREQ_UNIT: str = "Единица частоты LFO"; break; case STR_PS_EXP_FREQ: str = "Экспоненц.частота"; break; case STR_PS_EXP_AMP: str = "Экспоненц.амплитуда"; break;
 case STR_PS_ROLLOFF: str = "Крутизна"; break; case STR_PS_C_VOLUME: str = "Н.Громкость"; break;
 case STR_PS_C_FREQ_RATIO: str = "Н.Коэф.частоты"; break; case STR_PS_C_ATTACK: str = "Н.Атака"; break; case STR_PS_C_DECAY: str = "Н.Спад"; break; case STR_PS_C_SUSTAIN: str = "Н.Поддержка"; break; case STR_PS_C_RELEASE: str = "Н.Затухание"; break; case STR_PS_M_VOLUME: str = "М.Громкость"; break;
 case STR_PS_M_FREQ_RATIO: str = "М.Коэф.частоты"; break; case STR_PS_M_ATTACK: str = "М.Атака"; break; case STR_PS_M_DECAY: str = "М.Спад"; break; case STR_PS_M_SUSTAIN: str = "М.Поддержка"; break; case STR_PS_M_RELEASE: str = "М.Затухание"; break;
 case STR_PS_M_SELF_MOD: str = "М.Самомодуляция"; break;
 case STR_PS_M_SCALING: str = "М.Зависимость от ноты"; break; case STR_PS_OUT: str = "Выход"; break; case STR_PS_OUT_PIN: str = "Выходная нога"; break; case STR_PS_OUT_THRESHOLD: str = "Выходной порог"; break; case STR_PS_IN: str = "Вход"; break; case STR_PS_IN_PIN: str = "Входная нога"; break; case STR_PS_IN_NOTE: str = "Входная нота"; break;
 case STR_PS_IN_AMP: str = "Входная амплитуда"; break; case STR_PS_ADD_VOL: str = "Усиление"; break; case STR_PS_ENV_ACCEL: str = "Ускорение"; break; case STR_PS_NO_CLICK_AT_THE_BEGINNING: str = "Без щелчка"; break; case STR_PS_SET_PHASE: str = "Установить фазу"; break; case STR_PS_FREQ_UNIT: str = "Единица частоты"; break; case STR_PS_REPEAT: str = "Повтор"; break; case STR_PS_LOOP_REPEAT: str = "Повтор (128=бесконечно)"; break;
 case STR_PS_CONTROLLERS: str = "Контроллеры"; break; case STR_PS_MODULATION_TYPE: str = "Тип модуляции"; break; case STR_PS_LOAD_RAW_DATA: str = "Загрузить файл"; break; case STR_PS_SAVE_RAW_DATA: str = "Сохранить файл"; break; case STR_PS_VOLUME_ENV_SCALING_PER_KEY: str = "Зависим. длины огиб. громкости от ноты"; break; case STR_PS_FILTER_ENV_SCALING_PER_KEY: str = "Зависим. длины огиб. фильтра от ноты"; break; case STR_PS_VOLUME_SCALING_PER_KEY: str = "Зависимость громкости от ноты"; break; case STR_PS_FILTER_FREQ_SCALING_PER_KEY: str = "Зависимость частоты фильтра от ноты"; break;
 case STR_PS_FILTER_FREQ_SCALING_PER_KEY2: str = "Обратная зависим. частоты фильтра от ноты"; break; case STR_PS_FILTER_FREQ_SCALING_ON_VEL: str = "Зависимость частоты фильтра от динамики"; break;
 case STR_PS_FILTER_RES_SCALING_ON_VEL: str = "Зависимость резонанса от динамики"; break; case STR_PS_FILTER_FREQ_IS_NOTE_FREQ: str = "Частота фильтра = частота ноты"; break; case STR_PS_FREQ_DIV_2: str = "Частота / 2"; break; case STR_PS_SMOOTH_FREQ_CHANGE: str = "Плавное изменение частоты"; break; case STR_PS_TRUE_ZERO_ATTACK_RELEASE: str = "Резкая атака/затухание"; break; case STR_PS_USE_STATIC_NOTE_C5: str = "Всегда играть ноту C5"; break; case STR_PS_IGNORE_NOTES_WITH_ZERO_VEL: str = "Отсекать ноты с нулевой динамикой"; break; case STR_PS_TRIGGER: str = "Триггер"; break; case STR_PS_GEN_MISSED_NOTEOFF: str = "Генерировать пропущенные Note OFF"; break;
 case STR_PS_ROUND_PITCH: str = "Округлять ноту X"; break; case STR_PS_ROUND_PITCH2: str = "Округлять высоту тона Y"; break; case STR_PS_REC_CURVE3: str = "Запись нот в звукоряд (кривая3)"; break;
 case STR_PS_NOTE_DIFFERENCE: str = "Вых.нота = вых.нота - вх.нота + C5"; break;
 case STR_PS_OUTSLOT_NOTE: str = "Вых.порт = нота % кол-во выходов"; break; case STR_PS_OUTSLOT_POLYCHANNEL: str = "Вых.порт = кан.полиф. % кол-во выходов"; break; case STR_PS_OUTSLOT_ROUNDROBIN: str = "Вых.порт = round-robin (цикл)"; break; case STR_PS_OUTSLOT_RANDOM1: str = "Вых.порт = случайный1"; break; case STR_PS_OUTSLOT_RANDOM2: str = "Вых.порт = случайный2"; break; case STR_PS_OUTSLOT_RANDOM3: str = "Вых.порт = случайный3 (без повторов)"; break; case STR_PS_VEL_CURVE: str = "Кривая динамики"; break; case STR_PS_PITCH_CURVE: str = "Кривая высоты тона"; break;
 case STR_PS_CURVE_DESCR: str = "(X-вход,Y-выход)"; break; case STR_PS_CURVE_TYPE: str = "Тип кривой"; break; case STR_PS_CURVE_TYPE1: str = "X = нота; Y = динамика"; break; case STR_PS_CURVE_TYPE2: str = "X = динамика; Y = динамика"; break;
 case STR_PS_CURVE_TYPE3: str = "X = нота; Y = высота тона"; break; case STR_PS_CURVE2_INFLUENCE: str = "Влияние кривой2"; break;
 case STR_PS_RANDOM_PITCH: str = "Случайный тон"; break; case STR_PS_VELOCITY: str = "Динамика"; break; case STR_PS_FINETUNE: str = "Подстройка"; break; case STR_PS_RANDOM_PHASE: str = "Случайная фаза"; break; case STR_PS_RANDOM_PHASE_LITE: str = "Случайная фаза (быстр.алгоритм)"; break; case STR_PS_RANDOM_VELOCITY: str = "Случайная динамика"; break;
 case STR_PS_PHASE: str = "Фаза"; break; case STR_PS_PITCH: str = "Тон"; break; case STR_PS_PITCH_SCALE: str = "Масштаб высоты тона"; break;
 case STR_PS_FREQ_SCALE: str = "Масштаб частоты"; break; case STR_PS_GRAIN_SIZE: str = "Размер гранулы"; break; case STR_PS_PLAY_ORIGINAL_IF_PITCH0: str = "Играть оригинал, если тон=0"; break;
 case STR_PS_DAMP: str = "Затухание через фильтр"; break; case STR_PS_FREEZE: str = "Заморозка"; break; case STR_PS_ALLPASS_FILTER: str = "Фазовый фильтр"; break; case STR_PS_ROOM_SIZE: str = "Размер комнаты"; break; case STR_PS_RANDOM_SEED: str = "Случайная вариация"; break; case STR_PS_SAMPLE_INTERPOLATION: str = "Интерполяция сэмпла"; break; case STR_PS_ENVELOPE_INTERPOLATION: str = "Интерполяция огибающей"; break; case STR_PS_REC_THRESHOLD: str = "Порог начала записи"; break; case STR_PS_FILE_FORMAT_NOT_RECOGNIZED: str = "!Формат файла не распознан"; break; case STR_PS_LOAD_RAW_OR_CANCEL: str = "Грузить сырые данные;Отмена"; break; case STR_PS_CREATE_SAMPLE: str = "Создать новый сэмпл"; break; case STR_PS_DATA_FORMAT: str = "Формат данных"; break; case STR_PS_SAMPLE_TYPE: str = "Тип отсчета"; break; case STR_PS_SAMPLE_TYPES: str = "32бита (floating point)\n16бит\n8бит"; break;
 case STR_PS_IMPORT_SAMPLE_TYPES: str = "32бита (floating point)\n16бит\n8бит\n8бит (без знака)"; break; case STR_PS_CANT_CREATE_NEW_SAMPLE: str = "!Не могу создать сэмпл"; break; case STR_PS_FILE_EMPTY: str = "!Файл пустой"; break; case STR_PS_VIBRATO_TYPE: str = "Вибрато.тип"; break;
 case STR_PS_VIBRATO_TYPES: str = "sin;пила;прямоугольн."; break; case STR_PS_VIBRATO_ATTACK: str = "Вибрато.атака"; break;
 case STR_PS_VIBRATO_DEPTH: str = "Вибрато.амплитуда"; break; case STR_PS_VIBRATO_RATE: str = "Вибрато.скорость"; break;
 case STR_PS_VOLUME_FADE_OUT: str = "Затухание громкости"; break;
 case STR_PS_EFF1: str = "Контроллер1 эффекта"; break;
 case STR_PS_EFF2: str = "Контроллер2 эффекта"; break; case STR_PS_EFF3: str = "Контроллер3 эффекта"; break; case STR_PS_EFF4: str = "Контроллер4 эффекта"; break;
 case STR_PS_EFF1_SHORT: str = "Эфф.к1"; break; case STR_PS_EFF2_SHORT: str = "Эфф.к2"; break; case STR_PS_EFF3_SHORT: str = "Эфф.к3"; break; case STR_PS_EFF4_SHORT: str = "Эфф.к4"; break;
 case STR_PS_EFFMOD: str = "Модуль эффекта"; break; case STR_PS_DELETE_EFFMOD: str = "!Удалить модуль эффекта?"; break; case STR_PS_SET_SUSTAIN_POINT: str = "Установить точку удержания"; break; case STR_PS_SET_LOOP_START_POINT: str = "Установить начало петли"; break; case STR_PS_SET_LOOP_END_POINT: str = "Установить конец петли"; break; case STR_PS_ENV_POINT_LINE: str = "стр"; break; case STR_PS_ENV_POINT_TICK: str = "тик"; break; case STR_PS_DISABLED: str = "ВЫКЛЮЧЕНО"; break; case STR_PS_SAMPLE_LENGTH: str = "Длина (кол-во отсчетов)"; break; case STR_PS_SAMPLE_RATE: str = "Частота дискретизации"; break; case STR_PS_DELETE_SAMPLE: str = "!Удалить выбранный сэмпл?"; break; case STR_PS_LOAD_SAMPLE: str = "Загрузить сэмпл"; break; case STR_PS_SAVE_SAMPLE: str = "Сохранить сэмпл"; break; case STR_PS_LOOP: str = "Петля"; break; case STR_PS_LOOP_TYPES: str = "выкл;вкл;пинг-понг"; break; case STR_PS_SELECTED_SAMPLE: str = "Выбранный сэмпл"; break; case STR_PS_SHOW_SAMPLES: str = "Показывать сэмплы"; break;
 case STR_PS_SAMPLES: str = "Сэмплы"; break; case STR_PS_ENVELOPE: str = "Огибающая"; break; case STR_PS_ENVELOPES: str = "Огибающие"; break; case STR_PS_ACTIVE_NOTES_FOR_SAMPLE: str = "Диапазон нот выбранного сэмпла"; break; case STR_PS_SMP_EFFECTS: str = "Эффекты"; break; case STR_PS_SMP_EFF_SMOOTH: str = "Сглаживание"; break; case STR_PS_SMP_EFF_FADE: str = "Огибающая громкости"; break; case STR_PS_SMP_EFF_FADE_IN: str = "Нарастание"; break;
 case STR_PS_SMP_EFF_FADE_OUT: str = "Затухание"; break; case STR_PS_SMP_EFF_NORMALIZE: str = "Нормализация"; break; case STR_PS_SMP_EFF_REVERSE: str = "Переворот"; break; case STR_PS_SMP_EFF_INVERT: str = "Инверсия"; break; case STR_PS_SMP_EFF_CENTER: str = "Центрировать"; break; case STR_PS_SMP_EFF_CROSSFADE_LOOP: str = "Петля без щелчков"; break; case STR_PS_SMP_NO_LOOP: str = "!Петля не задана"; break; case STR_PS_SMP_WRONG_LOOP: str = "!Петля должна быть обычная (тип пинг-понг не поддерживается этим эффектом)"; break; case STR_PS_SMP_CROSSFADE_OR_CANCEL: str = "100%;75%;50%;25%;1%;Отмена"; break;
 case STR_PS_SMP_PROPS: str = "Прочее"; break; case STR_PS_SMP_PROPS_MENU: str = "Изменить базовую частоту дискр.\nРесэмплинг (новая частота)\nРесэмплинг (новая длина)\nСтерео в моно"; break; case STR_PS_BASE_SAMPLE_RATE: str = "Базовая частота дискретизации:"; break; case STR_PS_NEW_SAMPLE_RATE: str = "Новая частота дискретизации:"; break;
 case STR_PS_NEW_LENGTH_SAMPLES: str = "Новая длина (кол-во отсчетов):"; break; case STR_PS_CONVERT_STEREO_TO_MONO: str = "!Преобразовать из стерео в моно?"; break;
 case STR_PS_INITIAL_VOL: str = "Начальная громкость (%):"; break; case STR_PS_FINAL_VOL: str = "Конечная громкость (%):"; break; case STR_PS_DELETE_ALL: str = "Удалить все"; break; case STR_PS_CROP: str = "Обрезать"; break;
 case STR_PS_SET_LOOP: str = "Установить петлю"; break; case STR_PS_PAINT_MODE_ONOFF: str = "Режим рисования Вкл/Выкл"; break;
 case STR_PS_SAMPLE: str = "Cэмпл"; break; case STR_PS_OFFSET_FOR: str = "смещение для"; break; case STR_PS_RECORD_ON_PLAY: str = "Начать запись синхронно с проектом"; break; case STR_PS_FINISH_RECORD_ON_STOP: str = "Остановить запись синхронно с проектом"; break; case STR_PS_RECORD_IN_MONO: str = "Запись в моно"; break; case STR_PS_RECORD_WITH_REDUCED_SAMPLE_RATE: str = "Запись с уменьш.частотой дискр."; break;
 case STR_PS_RECORD_IN_16BIT: str = "Запись в 16бит"; break; case STR_PS_IGNORE_VEL_FOR_VOLUME: str = "Громк. не зависит от динамики"; break;
 case STR_PS_INCREASED_FREQ_ACCURACY: str = "Повыш. точность вычисления частоты"; break; case STR_PS_NOTHING_TO_RECORD: str = "!Нечего записывать. Ко входу Sampler'а не подключен ни один модуль"; break; case STR_PS_CONTINUE_CANCEL: str = "Продолжить;Отмена"; break; case STR_PS_SAMPLER_EDITOR: str = "Многосэмпловый инструмент"; break;
 case STR_PS_BASE_NOTE: str = "Базовая нота"; break; case STR_PS_BASE_NOTES: str = "Базовые ноты:"; break; case STR_PS_ALGORITHM: str = "Алгоритм"; break;
 case STR_PS_OUT_MIN: str = "Вых.минимум"; break; case STR_PS_OUT_MAX: str = "Вых.максимум"; break; case STR_PS_OUT_OFFSET: str = "Вых.смещение"; break; case STR_PS_OUT_CTL: str = "Вых.контроллер"; break;
 case STR_PS_RECORD_VALUES: str = "Записывать значения"; break; case STR_PS_RECORD_NOTES: str = "Записывать ноты"; break; case STR_PS_VALUES: str = "Значения"; break; case STR_PS_SPECTRUM_RESOLUTION: str = "Разрешение спектра"; break; case STR_PS_HARMONIC: str = "Гармоника"; break; case STR_PS_HARMONIC_FREQ: str = "Г.частота"; break; case STR_PS_HARMONIC_VOLUME: str = "Г.громкость"; break; case STR_PS_HARMONIC_WIDTH: str = "Г.ширина"; break; case STR_PS_HARMONIC_TYPE: str = "Г.тип"; break; case STR_PS_SPECTRUM_SIZE: str = "Размер спектра"; break;
 case STR_PS_FORMANT_WIDTH: str = "Ширина форманты"; break; case STR_PS_INTENSITY: str = "Интенсивность"; break; case STR_PS_FORMANTS: str = "Кол-во формант"; break;
 case STR_PS_VOWEL: str = "Гласная (а,е,и,о,у)"; break;
 case STR_PS_VOWEL2: str = "Гласная"; break; case STR_PS_VOICE_TYPE: str = "Тип голоса"; break; case STR_PS_RANDOM_FREQ: str = "Случайная частота"; break; case STR_PS_ORIGINAL_SPEED: str = "Не менять скорость"; break; case STR_PS_INTERPOLATION: str = "Интерполяция"; break; case STR_PS_LOAD_OGG_VORBIS_FILE: str = "Загрузить аудиофайл в формате OGG"; break; case STR_PS_INPUT_VOLUME: str = "Громкость входа"; break; case STR_PS_OUTPUT_VOLUME: str = "Громкость выхода"; break; case STR_PS_SYMMETRIC: str = "Симметричный"; break; case STR_PS_DC_BLOCKER: str = "Фильтр DC смещения"; break; case STR_PS_FILTER2_GAIN: str = "Уровень"; break; case STR_PS_RESET_ON_1ST_NOTE: str = "Сброс на 1й ноте"; break; case STR_PS_RESET: str = "Сброс"; break; case STR_PS_RETAIN_PHASE: str = "Не сбрасывать фазу"; break; case STR_PS_SET: str = "Установить"; break; case STR_PS_START_NOTE: str = "Начальная нота:"; break; case STR_PS_END_NOTE: str = "Конечная нота:"; break; case STR_PS_FREQ_OR_NOTE: str = "Частота (Гц) или нота:"; break;
 case STR_PS_START_VELOCITY: str = "Начальное знач. динамики"; break; case STR_PS_END_VELOCITY: str = "Конечное знач. динамики"; break; case STR_PS_REPEAT_WITH_PERIOD: str = "Период повтора"; break; case STR_PS_FIRST_NOTE: str = "Первая нота"; break; case STR_PS_GENERATOR: str = "Генератор"; break;
 case STR_PS_NOT_COMPATIBLE_MSG: str = "!К сожалению, данная функция не доступна в версии для вашего устройства"; break; case STR_PS_SEND_CHANGES_ONLY: str = "Посылать только измененные значения"; break; case STR_PS_ATTACK_CURVE: str = "Кривая атаки"; break; case STR_PS_DECAY_CURVE: str = "Кривая спада"; break; case STR_PS_RELEASE_CURVE: str = "Кривая затухания"; break; case STR_PS_STATE: str = "Состояние"; break; case STR_PS_ON_NOTEON: str = "При вкл.ноты"; break; case STR_PS_ON_NOTEOFF: str = "При выкл.ноты"; break; case STR_PS_SMOOTH_TRANSITIONS: str = "Плавные переходы"; break; case STR_PS_SMOOTH_TRANSITIONS2: str = "Плавные переходы ADSR"; break;
 case STR_PS_NOTEON_MODE: str = "Вкл. ноты"; break; case STR_PS_NOTEOFF_MODE: str = "Выкл. ноты"; break;
 case STR_PS_RANGE_SEMITONES: str = "Диапазон (кол-во полутонов)"; break; case STR_PS_DETECTOR_BASE_FREQS: str = "Базовые частоты детектора"; break; case STR_PS_MICROTONES: str = "Микротоны"; break; case STR_PS_DETECTOR_FINETUNE: str = "Подстройка детектора"; break; case STR_PS_LP_FILTER_FREQ: str = "Частота НЧ фильтра (0 - выкл)"; break; case STR_PS_LP_FILTER_ROLLOFF: str = "Крутизна НЧ фильтра"; break; case STR_PS_PD_ALG1_SAMPLE_RATE: str = "Алг1-2 Частота дискретизации (Гц)"; break; case STR_PS_PD_ALG1_BUF_SIZE: str = "Алг1-2 Буфер (мс)"; break;
 case STR_PS_PD_ALG1_BUF_OVERLAP: str = "Алг1-2 Перекрытие буферов"; break; case STR_PS_PD_ALG1_ABS_THRESHOLD: str = "Алг1 Чувствительность"; break; case STR_PS_ENV_SCALING: str = "Зависим. длины огиб. от ноты"; break; case STR_PS_VOL_SCALING: str = "Зависим. громк. от ноты"; break; case STR_PS_VEL_SENS: str = "Влияние динамики"; break; case STR_PS_FREQ_MUL: str = "Множитель частоты"; break; case STR_PS_CONST_PITCH: str = "Постоянная высота тона"; break; case STR_PS_OUTPUT: str = "Выход"; break;
 case STR_PS_OUTPUT_MODE: str = "Выходной режим"; break; case STR_PS_SELF_MOD: str = "Самомодуляция"; break; case STR_PS_BUF_SIZE: str = "Буфер (кол-во сэмплов)"; break; case STR_PS_INPUT_TO_OP: str = "Вход -> Оператор #"; break; case STR_PS_INPUT_TO_CUSTOMWAVE: str = "Вход -> Польз. форма волны"; break; case STR_PS_NOISE_FILTER: str = "Фильтр шума (32768 - выкл)"; break;
 case STR_PS_BUF_OVERLAP: str = "Перекрытие буферов"; break; case STR_PS_NOISE_REDUCTION: str = "Подавление шума"; break;
 case STR_PS_FFT_PHASE_GAIN: str = "Усиление фазы (норм=16384)"; break; case STR_PS_RANDOM_FREQ_SPREAD: str = "Разброс частот"; break; case STR_PS_FREQ_SHIFT: str = "Сдвиг частот"; break; case STR_PS_LP_CUTOFF: str = "НЧ срез"; break; case STR_PS_HP_CUTOFF: str = "ВЧ срез"; break; case STR_PS_ENV_GAIN: str = "Усиление огибающих"; break; case STR_PS_SIN_QUALITY: str = "Качество синуса"; break;
 case STR_PS_LENGTH: str = "Длина"; break; case STR_PS_LENGTH_UNIT: str = "Единица длины"; break;
 case STR_PS_MAX_BUF_SIZE: str = "Макс. размер буфера"; break;  default: break; }
 if( str ) break;
 }  switch( str_id ) { case STR_PS_OFF_ON: str = "off;on"; break; case STR_PS_STEREO_MONO: str = "stereo;mono"; break; case STR_PS_MONO_STEREO: str = "mono;stereo"; break; case STR_PS_GEN_WAVE_TYPES: str = "triangle;saw;square;noise (sampler);drawn;sin;hsin;asin;psin"; break; case STR_PS_GEN2_WAVE_TYPES: str = "triangle;saw;square;noise (sampler);drawn;sin;hsin;asin;drawn spline;noise spline (sampler);white noise;pink noise;red noise;blue noise;violet noise;grey noise;harmonics"; break; case STR_PS_GEN2_FILTER_TYPES: str = "off;LP 12dB;HP 12dB;BP 12dB;BR 12dB;LP 24dB;HP 24dB;BP 24dB;BR 24dB"; break; case STR_PS_GEN2_F_ENVELOPE_TYPES: str = "off;sustainOFF;sustainON"; break; case STR_PS_GEN2_OSC2_MODES: str = "add;sub;mul;min;max;bitwise AND;bitwise XOR"; break; case STR_PS_FILTER_TYPES: str = "LP;HP;BP;Notch"; break; case STR_PS_DELAY_UNITS: str = "sec/16384;ms;Hz;tick;line;line/2;line/3;sec/44100;sec/48000;sample"; break; case STR_PS_ECHO_DELAY_UNITS: str = "sec/256;ms;Hz;tick;line;line/2;line/3"; break; case STR_PS_ECHO_FILTERS: str = "off;LP 6dB;HP 6dB"; break; case STR_PS_FILTER_LFO_WAVEFORM_TYPES: str = "sin;saw;saw2;square;random"; break; case STR_PS_FILTER_LFO_FREQ_UNITS: str = "Hz*0.02;ms;Hz;tick;line;line/2;line/3"; break; case STR_PS_FILTER_ROLLOFF_VALS: str = "12dB;24dB;36dB;48dB"; break; case STR_PS_FILTER2_TYPES: str = "LP;HP;BP const.skirt gain;BP const.peak gain;Notch;All-pass;Peaking;Low shelf;High shelf;LP 6dB;HP 6dB"; break; case STR_PS_FILTER2_MODES: str = "stereo;mono;stereo + smoothing;mono + smoothing"; break; case STR_PS_FLANGER_LFO_FREQ_UNITS: str = "Hz*0.05;ms;Hz;tick;line;line/2;line/3"; break; case STR_PS_KICKER_WAVE_TYPES: str = "triangle;square;sin"; break; case STR_PS_LFO_TYPES: str = "amplitude;panning"; break;
 case STR_PS_LFO_WAVEFORM_TYPES: str = "sin;square;sin2;saw;saw2;random;triangle;random interpolated"; break; case STR_PS_LFO_FREQ_UNITS: str = "Hz/64;ms;Hz;tick;line;line/2;line/3"; break;
 case STR_PS_LFO_SMOOTH_TRANSITIONS: str = "off;waveform"; break; case STR_PS_MODULATION_TYPES: str = "amplitude;phase;phase (absolute)"; break; case STR_PS_MODULATION_TYPES2: str = "phase;frequency;amplitude (mul);add;sub;min;max;bitwise AND;bitwise XOR;phase+"; break; case STR_PS_INTERP_TYPES:
 case STR_PS_SAMPLE_INTERP_TYPES: str = "off;linear;spline"; break; case STR_PS_ENVELOPE_INTERP_TYPES: str = "off;linear"; break; case STR_PS_HARMONIC_TYPES: str = "hsin;rect;org1;org2;org3;org4;sin;random;triangle1;triangle2;overtones1;overtones2;overtones3;overtones4;overtones1+;overtones2+;overtones3+;overtones4+;metal"; break; case STR_PS_VOWEL_TYPES: str = "a;e;i;o;u"; break; case STR_PS_VOICE_TYPES: str = "soprano;alto;tenor;bass"; break; case STR_PS_LOOP_MODES: str = "normal;ping-pong"; break; case STR_PS_LOOP_LENGTH_UNITS: str = "line/128;line;line/2;line/3;tick;ms;Hz"; break;
 case STR_PS_LOOP_NOTEON_MODES: str = "restart;restart current iteration"; break;
 case STR_PS_PITCH2CTL_MODES: str = "frequency (Hz);pitch"; break; case STR_PS_PITCH2CTL_NOTEOFF_ACTION: str = "do nothing;pitch down;pitch up"; break; case STR_PS_VELOCITY2CTL_NOTEOFF_ACTION: str = "do nothing;vel.down;vel.up"; break; case STR_PS_METAMODULE_PLAY_PAT_MODES: str = "off;on (repeat);on (no repeat);on (repeat, endless);on (no repeat, endless)"; break; case STR_PS_COMPRESSOR_MODES: str = "peak;RMS;peak zero latency"; break;
 case STR_PS_DISTORTION_TYPES: str = "clipping;foldback;foldback2;foldback3;overflow;overflow2;saturation+foldback;saturation+foldback(sin);saturation3;saturation4;saturation5"; break;
 case STR_PS_STOP_START: str = "stop;start"; break; case STR_PS_ADSR_CURVE_TYPES: str = "linear;exp1;exp2;-exp1;-exp2;sin;rect;smooth rect;2bit;3bit;4bit;5bit"; break; case STR_PS_ADSR_MODES: str = "generator;amp.modulator mono;amp.modulator stereo"; break;
 case STR_PS_ADSR_NOTEON_ACTIONS: str = "do nothing;start on first note;start"; break; case STR_PS_ADSR_NOTEOFF_ACTIONS: str = "do nothing;stop on last note;stop"; break; case STR_PS_ADSR_SMOOTH_TRANSITIONS: str = "off;restart & volume change;restart (smoother) & volume change;volume change"; break;
 case STR_PS_ADSR_OFF_ON_REPEAT: str = "off;on;repeat"; break; case STR_PS_NOTEON_MODES: str = "-;on pitch change"; break; case STR_PS_NOTEOFF_MODES: str = "-;on min pitch;on max pitch"; break; case STR_PS_PD_ALGS: str = "fast (zero crossing);autocorrelation;cepstrum"; break; case STR_PS_PITCHSHIFTER_PLAYORIG_MODES: str = "off;slow transition;fast transition"; break;
 case STR_PS_CAPTURE_MODES: str = "off;single cycle;continuous"; break; case STR_PS_FM2_WAVE_TYPES: str = "custom;triangle;triangle^3;saw;saw^3;square;sin;hsin;asin;sin^3"; break; case STR_PS_SIN_Q_MODES: str = "auto;low;middle;high"; break;

 case STR_PS_CH: str = "ch."; break; case STR_PS_STEREO: str = "stereo"; break; case STR_PS_MONO: str = "mono"; break; case STR_PS_HZ: str = "Hz"; break;
 case STR_PS_HZ1000: str = "Hz/1000"; break;
 case STR_PS_MS: str = "ms"; break; case STR_PS_LEVELS: str = "levels"; break; case STR_PS_BIT: str = "bit"; break; case STR_PS_LINE128: str = "line/128"; break;
 case STR_PS_SEMITONE: str = "semitone"; break; case STR_PS_SEMITONE10: str = "semitone/10"; break; case STR_PS_SEMITONE64: str = "semitone/64"; break; case STR_PS_SEC: str = "sec"; break; case STR_PS_SEC256: str = "sec/256"; break;
 case STR_PS_DELAY_OFFSET15: str = "delay/32768"; break;
 case STR_PS_SMOOTH: str = "Smooth"; break; case STR_PS_VOLUME: str = "Volume"; break; case STR_PS_VOLUME_L: str = "Volume L"; break;
 case STR_PS_VOLUME_R: str = "Volume R"; break;
 case STR_PS_FINE_VOLUME: str = "Fine volume"; break; case STR_PS_WAVEFORM_TYPE: str = "Waveform"; break; case STR_PS_PANNING: str = "Panning"; break; case STR_PS_BALANCE: str = "Balance"; break;
 case STR_PS_ATTACK: str = "Attack"; break; case STR_PS_DECAY: str = "Decay"; break;
 case STR_PS_RELEASE: str = "Release"; break; case STR_PS_POLYPHONY: str = "Polyphony"; break;
 case STR_PS_MODE: str = "Mode"; break; case STR_PS_SUSTAIN: str = "Sustain"; break;
 case STR_PS_SUSTAIN_PEDAL: str = "Sustain pedal"; break; case STR_PS_SUSTAIN_LEVEL: str = "Sustain level"; break;
 case STR_PS_FREQ_MODULATION: str = "Freq.modulation by input"; break; case STR_PS_DUTY_CYCLE: str = "Duty cycle"; break; case STR_PS_DRAW_THIS_WAVEFORM: str = "You can draw this waveform"; break; case STR_PS_CHANNELS: str = "Channels"; break; case STR_PS_CHANNELS_NUM: str = "Number of channels"; break;
 case STR_PS_BASE: str = "Base"; break; case STR_PS_EXP_ENVELOPE: str = "Exponential envelope"; break; case STR_PS_FREQ: str = "Freq"; break; case STR_PS_FREQUENCY: str = "Frequency"; break;
 case STR_PS_FREQ_FINETUNE: str = "Freq finetune"; break;  case STR_PS_OSC2_PITCH: str = "Osc2"; break; case STR_PS_OSC2_VOL: str = "Osc2 volume"; break; case STR_PS_OSC2_MODE: str = "Osc2 mode"; break;
 case STR_PS_OSC2_PHASE: str = "Osc2 phase"; break; case STR_PS_FILTER: str = "Filter"; break; case STR_PS_F_FREQ: str = "F.freq"; break; case STR_PS_F_RESONANCE: str = "F.resonance"; break; case STR_PS_F_EXP_FREQ: str = "F.exponential freq"; break;
 case STR_PS_F_ATTACK: str = "F.attack"; break; case STR_PS_F_RELEASE: str = "F.release"; break;
 case STR_PS_F_ENVELOPE: str = "F.envelope"; break;
 case STR_PS_NOISE: str = "Noise"; break;
 case STR_PS_TYPE: str = "Type"; break; case STR_PS_TRANSPOSE: str = "Transpose"; break;
 case STR_PS_QUANTIZATION: str = "Quantization"; break;
 case STR_PS_GAIN: str = "Gain"; break; case STR_PS_VELOCITY_INFLUENCE: str = "Velocity influence"; break;
 case STR_PS_VALUE: str = "Value"; break; case STR_PS_CURVE: str = "Curve"; break; case STR_PS_CURVE_MULTICTL: str = "X = input value; Y = output value"; break; case STR_PS_SEND_VALUE_TO: str = "Send the value to:"; break; case STR_PS_DC_OFFSET: str = "DC Offset"; break; case STR_PS_BIPOLAR_DC_OFFSET: str = "Bipolar DC Offset"; break;
 case STR_PS_INVERSE: str = "Inverse"; break; case STR_PS_STEREO_WIDTH: str = "Stereo width"; break; case STR_PS_ABSOLUTE: str = "Absolute"; break; case STR_PS_DRY: str = "Dry"; break;
 case STR_PS_WET: str = "Wet"; break; case STR_PS_FEEDBACK: str = "Feedback"; break; case STR_PS_RESPONSE: str = "Response"; break; case STR_PS_DELAY: str = "Delay"; break; case STR_PS_DELAY_L: str = "Delay L"; break; case STR_PS_DELAY_R: str = "Delay R"; break; case STR_PS_DELAY_UNIT: str = "Delay unit"; break; case STR_PS_DELAY_MUL: str = "Delay multiplier"; break; case STR_PS_R_CHANNEL_OFFSET: str = "Right channel offset"; break; case STR_PS_LOW: str = "Low"; break; case STR_PS_MIDDLE: str = "Middle"; break;
 case STR_PS_HIGH: str = "High"; break; case STR_PS_RESONANCE: str = "Resonance"; break;
 case STR_PS_MIX: str = "Mix"; break;
 case STR_PS_BPM: str = "BPM (Beats Per Minute)"; break;
 case STR_PS_TPL: str = "TPL (Ticks Per Line)"; break;
 case STR_PS_USER_DEFINED: str = "User defined"; break; case STR_PS_USER_DEFINED_CONTROLLERS: str = "User defined controllers"; break;
 case STR_PS_NUMBER_OF_USER_DEFINED_CTLS: str = "Number of ctls"; break; case STR_PS_INPUT_MODULE: str = "Input module"; break; case STR_PS_PLAY_PATTERNS: str = "Play patterns"; break; case STR_PS_CONTROLLER: str = "Controller:"; break; case STR_PS_LINK_TO: str = "Link to:"; break; case STR_PS_CONTROLLER_NAME: str = "Controller name"; break; case STR_PS_ARPEGGIATOR: str = "Arpeggiator (base note - C5)"; break;
 case STR_PS_APPLY_VELOCITY_TO_PROJECT: str = "Apply velocity to project"; break; case STR_PS_EVT_OUT: str = "Event output"; break; case STR_PS_RECEIVE_NOTES_FROM_KBD: str = "Receive notes from the keyboard"; break; case STR_PS_DONT_RECEIVE_NOTES_FROM_KBD: str = "Don't receive notes from the keyboard"; break; case STR_PS_WARNING_MODULE_CANT_RECEIVE_SOUND: str = "can't receive sound"; break;
 case STR_PS_WARNING_MODULE_INPUT_CONNECTIONS: str = "must be w/o incoming connections"; break;
 case STR_PS_WARNING_MODULE_NONSTANDARD_INPUT: str = "nonstandard input type; try another module"; break;
 case STR_PS_AMPLITUDE: str = "Amplitude"; break;
 case STR_PS_SIDE_CHAIN: str = "Side-chain"; break; case STR_PS_SIDE_CHAIN_INPUT: str = "Side-chain input"; break; case STR_PS_NONE: str = "none"; break; case STR_PS_THRESHOLD: str = "Threshold"; break;
 case STR_PS_SLOPE: str = "Slope"; break; case STR_PS_POWER: str = "Power"; break; case STR_PS_BIT_DEPTH: str = "Bit depth"; break; case STR_PS_DRUMSYNTH_DESC: str = "C,c,D,d - bass drum\nE,F,f - hi-hat\nG,g,A,a,B - snare drum"; break;
 case STR_PS_BASS_VOLUME: str = "Bass volume"; break;
 case STR_PS_BASS_POWER: str = "Bass power"; break; case STR_PS_BASS_TONE: str = "Bass tone"; break; case STR_PS_BASS_LENGTH: str = "Bass length"; break; case STR_PS_BASS_PAN: str = "Bass panning"; break; case STR_PS_HIHAT_VOLUME: str = "Hihat volume"; break; case STR_PS_HIHAT_LENGTH: str = "Hihat length"; break; case STR_PS_HIHAT_PAN: str = "Hihat panning"; break;
 case STR_PS_SNARE_VOLUME: str = "Snare volume"; break; case STR_PS_SNARE_TONE: str = "Snare tone"; break; case STR_PS_SNARE_LENGTH: str = "Snare length"; break;
 case STR_PS_SNARE_PAN: str = "Snare panning"; break; case STR_PS_IMPULSE: str = "Impulse"; break; case STR_PS_LFO_FREQ: str = "LFO freq"; break;
 case STR_PS_LFO_AMP: str = "LFO amp"; break;
 case STR_PS_LFO_WAVEFORM: str = "LFO waveform"; break; case STR_PS_SET_LFO_PHASE: str = "Set LFO phase"; break; case STR_PS_LFO_FREQ_UNIT: str = "LFO freq unit"; break;
 case STR_PS_EXP_FREQ: str = "Exponential freq"; break; case STR_PS_EXP_AMP: str = "Exponential amplitude"; break;
 case STR_PS_ROLLOFF: str = "Roll-off"; break; case STR_PS_C_VOLUME: str = "C.Volume"; break; case STR_PS_C_FREQ_RATIO: str = "C.Freq ratio"; break;
 case STR_PS_C_ATTACK: str = "C.Attack"; break;
 case STR_PS_C_DECAY: str = "C.Decay"; break; case STR_PS_C_SUSTAIN: str = "C.Sustain"; break; case STR_PS_C_RELEASE: str = "C.Release"; break; case STR_PS_M_VOLUME: str = "M.Volume"; break; case STR_PS_M_FREQ_RATIO: str = "M.Freq ratio"; break; case STR_PS_M_ATTACK: str = "M.Attack"; break;
 case STR_PS_M_DECAY: str = "M.Decay"; break; case STR_PS_M_SUSTAIN: str = "M.Sustain"; break; case STR_PS_M_RELEASE: str = "M.Release"; break; case STR_PS_M_SELF_MOD: str = "M.Self-modulation"; break;
 case STR_PS_M_SCALING: str = "M.Scaling per key"; break; case STR_PS_OUT: str = "Out"; break; case STR_PS_OUT_PIN: str = "Out pin"; break; case STR_PS_OUT_THRESHOLD: str = "Out threshold"; break;
 case STR_PS_IN: str = "In"; break; case STR_PS_IN_PIN: str = "In pin"; break;
 case STR_PS_IN_NOTE: str = "In note"; break; case STR_PS_IN_AMP: str = "In amplitude"; break; case STR_PS_ADD_VOL: str = "Boost"; break; case STR_PS_ENV_ACCEL: str = "Acceleration"; break;
 case STR_PS_NO_CLICK_AT_THE_BEGINNING: str = "No click"; break; case STR_PS_SET_PHASE: str = "Set phase"; break;
 case STR_PS_FREQ_UNIT: str = "Frequency unit"; break; case STR_PS_REPEAT: str = "Repeat"; break; case STR_PS_LOOP_REPEAT: str = "Repeat (128=endless)"; break; case STR_PS_CONTROLLERS: str = "Controllers"; break;
 case STR_PS_MODULATION_TYPE: str = "Modulation type"; break; case STR_PS_LOAD_RAW_DATA: str = "Load RAW data"; break; case STR_PS_SAVE_RAW_DATA: str = "Save RAW data"; break; case STR_PS_VOLUME_ENV_SCALING_PER_KEY: str = "Volume envelope scaling per key"; break;
 case STR_PS_FILTER_ENV_SCALING_PER_KEY: str = "Filter envelope scaling per key"; break;
 case STR_PS_VOLUME_SCALING_PER_KEY: str = "Volume scaling per key"; break; case STR_PS_FILTER_FREQ_SCALING_PER_KEY: str = "Filter freq. scaling per key"; break; case STR_PS_FILTER_FREQ_SCALING_PER_KEY2: str = "Filter freq. scaling per key (reverse)"; break; case STR_PS_FILTER_FREQ_IS_NOTE_FREQ: str = "Filter freq. = note freq."; break; case STR_PS_FILTER_FREQ_SCALING_ON_VEL: str = "Velocity-dependent filter frequency"; break;
 case STR_PS_FILTER_RES_SCALING_ON_VEL: str = "Velocity-dependent filter resonance"; break; case STR_PS_FREQ_DIV_2: str = "Frequency / 2"; break; case STR_PS_SMOOTH_FREQ_CHANGE: str = "Smooth frequency change"; break; case STR_PS_TRUE_ZERO_ATTACK_RELEASE: str = "True zero attack/release"; break; case STR_PS_USE_STATIC_NOTE_C5: str = "Use static note C5"; break;
 case STR_PS_IGNORE_NOTES_WITH_ZERO_VEL: str = "Ignore notes with zero velocity"; break; case STR_PS_TRIGGER: str = "Trigger (ignore Note OFF)"; break; case STR_PS_GEN_MISSED_NOTEOFF: str = "Generate missed Note OFF cmds"; break; case STR_PS_ROUND_PITCH: str = "Round note X"; break; case STR_PS_ROUND_PITCH2: str = "Round pitch Y"; break;
 case STR_PS_REC_CURVE3: str = "Record notes to the scale (curve3)"; break;
 case STR_PS_NOTE_DIFFERENCE: str = "Out.note = Out.note - In.note + C5"; break; case STR_PS_OUTSLOT_NOTE: str = "Out.port = note % num of outs"; break; case STR_PS_OUTSLOT_POLYCHANNEL: str = "Out.port = poly.ch. % num of outs"; break; case STR_PS_OUTSLOT_ROUNDROBIN: str = "Out.port = round-robin (cyclic)"; break;
 case STR_PS_OUTSLOT_RANDOM1: str = "Out.port = random1"; break;
 case STR_PS_OUTSLOT_RANDOM2: str = "Out.port = random2"; break; case STR_PS_OUTSLOT_RANDOM3: str = "Out.port = random3 (no repeats)"; break; case STR_PS_VEL_CURVE: str = "Velocity curve"; break;
 case STR_PS_PITCH_CURVE: str = "Pitch curve"; break; case STR_PS_CURVE_DESCR: str = "(X-in,Y-out)"; break; case STR_PS_CURVE_TYPE: str = "Curve type"; break; case STR_PS_CURVE_TYPE1: str = "X = note; Y = velocity"; break; case STR_PS_CURVE_TYPE2: str = "X = velocity; Y = velocity"; break; case STR_PS_CURVE_TYPE3: str = "X = note; Y = pitch"; break;
 case STR_PS_CURVE2_INFLUENCE: str = "Curve2 influence"; break; case STR_PS_RANDOM_PITCH: str = "Random pitch"; break;
 case STR_PS_VELOCITY: str = "Velocity"; break;
 case STR_PS_FINETUNE: str = "Finetune"; break;
 case STR_PS_RANDOM_PHASE: str = "Random phase"; break; case STR_PS_RANDOM_PHASE_LITE: str = "Random phase (lite)"; break;
 case STR_PS_RANDOM_VELOCITY: str = "Random velocity"; break; case STR_PS_PHASE: str = "Phase"; break; case STR_PS_PITCH: str = "Pitch"; break; case STR_PS_PITCH_SCALE: str = "Pitch scale"; break; case STR_PS_FREQ_SCALE: str = "Freq scale"; break;
 case STR_PS_GRAIN_SIZE: str = "Grain size"; break; case STR_PS_PLAY_ORIGINAL_IF_PITCH0: str = "Bypass if pitch=0"; break; case STR_PS_DAMP: str = "Damp"; break;
 case STR_PS_FREEZE: str = "Freeze"; break;
 case STR_PS_ALLPASS_FILTER: str = "All-pass filter"; break; case STR_PS_ROOM_SIZE: str = "Room size"; break; case STR_PS_RANDOM_SEED: str = "Random seed"; break; case STR_PS_SAMPLE_INTERPOLATION: str = "Sample interpolation"; break;
 case STR_PS_ENVELOPE_INTERPOLATION: str = "Envelope interpolation"; break; case STR_PS_REC_THRESHOLD: str = "Rec threshold"; break; case STR_PS_FILE_FORMAT_NOT_RECOGNIZED: str = "!File format not recognized"; break; case STR_PS_LOAD_RAW_OR_CANCEL: str = "Load raw data;Cancel"; break;
 case STR_PS_CREATE_SAMPLE: str = "Create a new sample"; break; case STR_PS_DATA_FORMAT: str = "Data format"; break;
 case STR_PS_SAMPLE_TYPE: str = "Sample type"; break;
 case STR_PS_SAMPLE_TYPES: str = "32bit (floating point)\n16bit\n8bit"; break; case STR_PS_IMPORT_SAMPLE_TYPES: str = "32bit (floating point)\n16bit\n8bit\n8bit (unsigned)"; break;
 case STR_PS_CANT_CREATE_NEW_SAMPLE: str = "!Can't create a new sample"; break; case STR_PS_FILE_EMPTY: str = "!File is empty"; break;
 case STR_PS_VIBRATO_TYPE: str = "Vibrato type"; break; case STR_PS_VIBRATO_TYPES: str = "sin;saw;square"; break; case STR_PS_VIBRATO_ATTACK: str = "Vibrato attack"; break; case STR_PS_VIBRATO_DEPTH: str = "Vibrato depth"; break; case STR_PS_VIBRATO_RATE: str = "Vibrato rate"; break; case STR_PS_VOLUME_FADE_OUT: str = "Volume fade out"; break; case STR_PS_EFF1: str = "Effect controller1"; break;
 case STR_PS_EFF2: str = "Effect controller2"; break; case STR_PS_EFF3: str = "Effect controller3"; break; case STR_PS_EFF4: str = "Effect controller4"; break; case STR_PS_EFF1_SHORT: str = "Eff.ctl1"; break; case STR_PS_EFF2_SHORT: str = "Eff.ctl2"; break; case STR_PS_EFF3_SHORT: str = "Eff.ctl3"; break; case STR_PS_EFF4_SHORT: str = "Eff.ctl4"; break; case STR_PS_EFFMOD: str = "Eff.module"; break; case STR_PS_DELETE_EFFMOD: str = "!Delete effect module?"; break;
 case STR_PS_SET_SUSTAIN_POINT: str = "Set sustain point"; break;
 case STR_PS_SET_LOOP_START_POINT: str = "Set loop start point"; break;
 case STR_PS_SET_LOOP_END_POINT: str = "Set loop end point"; break; case STR_PS_ENV_POINT_LINE: str = "line"; break;
 case STR_PS_ENV_POINT_TICK: str = "tick"; break; case STR_PS_DISABLED: str = "DISABLED"; break; case STR_PS_SAMPLE_LENGTH: str = "Length (number of samples)"; break; case STR_PS_SAMPLE_RATE: str = "Sample rate"; break; case STR_PS_DELETE_SAMPLE: str = "!Delete selected sample?"; break; case STR_PS_LOAD_SAMPLE: str = "Load sample"; break; case STR_PS_SAVE_SAMPLE: str = "Save sample"; break; case STR_PS_LOOP: str = "Loop"; break; case STR_PS_LOOP_TYPES: str = "off;on;ping pong"; break;
 case STR_PS_SELECTED_SAMPLE: str = "Selected sample"; break; case STR_PS_SHOW_SAMPLES: str = "Show samples"; break; case STR_PS_SAMPLES: str = "Samples"; break; case STR_PS_ENVELOPE: str = "Envelope"; break; case STR_PS_ENVELOPES: str = "Envelopes"; break; case STR_PS_ACTIVE_NOTES_FOR_SAMPLE: str = "Active notes for selected sample"; break;
 case STR_PS_SMP_EFFECTS: str = "Effects"; break; case STR_PS_SMP_EFF_SMOOTH: str = "Smooth"; break; case STR_PS_SMP_EFF_FADE: str = "Fade"; break; case STR_PS_SMP_EFF_FADE_IN: str = "Fade in"; break; case STR_PS_SMP_EFF_FADE_OUT: str = "Fade out"; break; case STR_PS_SMP_EFF_NORMALIZE: str = "Normalize"; break;
 case STR_PS_SMP_EFF_REVERSE: str = "Reverse"; break; case STR_PS_SMP_EFF_INVERT: str = "Invert"; break; case STR_PS_SMP_EFF_CENTER: str = "Center"; break; case STR_PS_SMP_EFF_CROSSFADE_LOOP: str = "Crossfade loop"; break; case STR_PS_SMP_NO_LOOP: str = "!Please turn on the loop"; break; case STR_PS_SMP_WRONG_LOOP: str = "!Wrong loop type: ping pong is not supported by this effect"; break; case STR_PS_SMP_CROSSFADE_OR_CANCEL: str = "100%;75%;50%;25%;1%;Cancel"; break; case STR_PS_SMP_PROPS: str = "Misc"; break;
 case STR_PS_SMP_PROPS_MENU: str = "Change base sample rate\nResample (new sample rate)\nResample (new length)\nStereo to mono"; break; case STR_PS_BASE_SAMPLE_RATE: str = "Base sample rate:"; break; case STR_PS_NEW_SAMPLE_RATE: str = "New sample rate:"; break; case STR_PS_NEW_LENGTH_SAMPLES: str = "New length (number of samples):"; break; case STR_PS_CONVERT_STEREO_TO_MONO: str = "!Convert stereo to mono?"; break; case STR_PS_INITIAL_VOL: str = "Initial volume (%):"; break; case STR_PS_FINAL_VOL: str = "Final volume (%):"; break;
 case STR_PS_DELETE_ALL: str = "Delete all"; break; case STR_PS_CROP: str = "Crop"; break;
 case STR_PS_SET_LOOP: str = "Set loop"; break; case STR_PS_PAINT_MODE_ONOFF: str = "Paint mode ON/OFF"; break;
 case STR_PS_SAMPLE: str = "Sample"; break; case STR_PS_OFFSET_FOR: str = "offset for"; break;
 case STR_PS_RECORD_ON_PLAY: str = "Start recording on project play"; break; case STR_PS_FINISH_RECORD_ON_STOP: str = "Stop recording on project stop"; break; case STR_PS_RECORD_IN_MONO: str = "Record in mono"; break; case STR_PS_RECORD_WITH_REDUCED_SAMPLE_RATE: str = "Record with reduced sample rate"; break; case STR_PS_RECORD_IN_16BIT: str = "Record in 16bit"; break; case STR_PS_IGNORE_VEL_FOR_VOLUME: str = "Ignore velocity for volume"; break; case STR_PS_INCREASED_FREQ_ACCURACY: str = "Increased freq. computation accuracy"; break; case STR_PS_NOTHING_TO_RECORD: str = "!Nothing to record. No modules connected to this Sampler"; break; case STR_PS_CONTINUE_CANCEL: str = "Continue;Cancel"; break;
 case STR_PS_SAMPLER_EDITOR: str = "Multisample instrument"; break; case STR_PS_BASE_NOTE: str = "Base note"; break;
 case STR_PS_BASE_NOTES: str = "Base note(s):"; break;
 case STR_PS_ALGORITHM: str = "Algorithm"; break; case STR_PS_OUT_MIN: str = "OUT min"; break;
 case STR_PS_OUT_MAX: str = "OUT max"; break; case STR_PS_OUT_OFFSET: str = "OUT offset"; break; case STR_PS_OUT_CTL: str = "OUT controller"; break; case STR_PS_RECORD_VALUES: str = "Record values"; break; case STR_PS_RECORD_NOTES: str = "Record notes"; break; case STR_PS_VALUES: str = "Values"; break; case STR_PS_SPECTRUM_RESOLUTION: str = "Spectrum resolution"; break; case STR_PS_HARMONIC: str = "Harmonic"; break; case STR_PS_HARMONIC_FREQ: str = "H.freq"; break; case STR_PS_HARMONIC_VOLUME: str = "H.volume"; break; case STR_PS_HARMONIC_WIDTH: str = "H.width"; break; case STR_PS_HARMONIC_TYPE: str = "H.type"; break; case STR_PS_SPECTRUM_SIZE: str = "Spectrum size"; break; case STR_PS_FORMANT_WIDTH: str = "Formant width"; break; case STR_PS_INTENSITY: str = "Intensity"; break; case STR_PS_FORMANTS: str = "Formants"; break; case STR_PS_VOWEL: str = "Vowel (a,e,i,o,u)"; break; case STR_PS_VOWEL2: str = "Vowel"; break; case STR_PS_VOICE_TYPE: str = "Voice type"; break; case STR_PS_RANDOM_FREQ: str = "Random frequency"; break; case STR_PS_ORIGINAL_SPEED: str = "Original speed"; break; case STR_PS_INTERPOLATION: str = "Interpolation"; break; case STR_PS_LOAD_OGG_VORBIS_FILE: str = "Load OGG Vorbis file"; break; case STR_PS_INPUT_VOLUME: str = "Input volume"; break; case STR_PS_OUTPUT_VOLUME: str = "Output volume"; break;
 case STR_PS_SYMMETRIC: str = "Symmetric"; break; case STR_PS_DC_BLOCKER: str = "DC blocker"; break; case STR_PS_FILTER2_GAIN: str = "Gain"; break;
 case STR_PS_RESET_ON_1ST_NOTE: str = "Reset on 1st note"; break; case STR_PS_RESET: str = "Reset"; break; case STR_PS_RETAIN_PHASE: str = "Retain phase"; break;
 case STR_PS_SET: str = "Set"; break; case STR_PS_START_NOTE: str = "Start note:"; break; case STR_PS_END_NOTE: str = "End note:"; break; case STR_PS_FREQ_OR_NOTE: str = "Frequency (Hz) or note:"; break; case STR_PS_START_VELOCITY: str = "Start velocity"; break;
 case STR_PS_END_VELOCITY: str = "End velocity"; break; case STR_PS_REPEAT_WITH_PERIOD: str = "Repeat with period"; break; case STR_PS_FIRST_NOTE: str = "First note"; break; case STR_PS_GENERATOR: str = "Generator"; break; case STR_PS_NOT_COMPATIBLE_MSG: str = "!Sorry, but this feature is not compatible with your device"; break; case STR_PS_SEND_CHANGES_ONLY: str = "Send only changed values"; break; case STR_PS_ATTACK_CURVE: str = "Attack curve"; break;
 case STR_PS_DECAY_CURVE: str = "Decay curve"; break; case STR_PS_RELEASE_CURVE: str = "Release curve"; break;
 case STR_PS_STATE: str = "State"; break;
 case STR_PS_ON_NOTEON: str = "On NoteON"; break; case STR_PS_ON_NOTEOFF: str = "On NoteOFF"; break;
 case STR_PS_SMOOTH_TRANSITIONS: str = "Smooth transitions"; break; case STR_PS_SMOOTH_TRANSITIONS2: str = "ADSR smooth transitions"; break; case STR_PS_NOTEON_MODE: str = "NoteON"; break; case STR_PS_NOTEOFF_MODE: str = "NoteOFF"; break;
 case STR_PS_RANGE_SEMITONES: str = "Range (number of semitones)"; break;
 case STR_PS_DETECTOR_BASE_FREQS: str = "Detector base frequencies"; break; case STR_PS_MICROTONES: str = "Microtones"; break; case STR_PS_DETECTOR_FINETUNE: str = "Detector finetune"; break;
 case STR_PS_LP_FILTER_FREQ: str = "LP filter freq (0 - OFF)"; break; case STR_PS_LP_FILTER_ROLLOFF: str = "LP filter roll-off"; break; case STR_PS_PD_ALG1_SAMPLE_RATE: str = "Alg1-2 Sample rate (Hz)"; break; case STR_PS_PD_ALG1_BUF_SIZE: str = "Alg1-2 Buffer (ms)"; break; case STR_PS_PD_ALG1_BUF_OVERLAP: str = "Alg1-2 Buf overlap"; break; case STR_PS_PD_ALG1_ABS_THRESHOLD: str = "Alg1 Sensitivity (absolute threshold)"; break; case STR_PS_ENV_SCALING: str = "Envelope scaling per key"; break;
 case STR_PS_VOL_SCALING: str = "Volume scaling per key"; break; case STR_PS_VEL_SENS: str = "Velocity sensitivity"; break; case STR_PS_FREQ_MUL: str = "Freq multiply"; break; case STR_PS_CONST_PITCH: str = "Constant pitch"; break;
 case STR_PS_OUTPUT: str = "Output"; break;
 case STR_PS_OUTPUT_MODE: str = "Output mode"; break; case STR_PS_SELF_MOD: str = "Self-modulation"; break;
 case STR_PS_BUF_SIZE: str = "Buffer (samples)"; break;
 case STR_PS_INPUT_TO_OP: str = "Input -> Operator #"; break;
 case STR_PS_INPUT_TO_CUSTOMWAVE: str = "Input -> Custom waveform"; break;
 case STR_PS_NOISE_FILTER: str = "Noise filter (32768 - OFF)"; break; case STR_PS_BUF_OVERLAP: str = "Buf overlap"; break; case STR_PS_NOISE_REDUCTION: str = "Noise reduction"; break; case STR_PS_FFT_PHASE_GAIN: str = "Phase gain (norm=16384)"; break; case STR_PS_RANDOM_FREQ_SPREAD: str = "Frequency spread"; break; case STR_PS_FREQ_SHIFT: str = "Freq shift"; break; case STR_PS_LP_CUTOFF: str = "LP cutoff"; break; case STR_PS_HP_CUTOFF: str = "HP cutoff"; break; case STR_PS_ENV_GAIN: str = "Envelope gain"; break; case STR_PS_SIN_QUALITY: str = "Sine quality"; break; case STR_PS_LENGTH: str = "Length"; break; case STR_PS_LENGTH_UNIT: str = "Length unit"; break; case STR_PS_MAX_BUF_SIZE: str = "Max buffer size"; break;
 default: break;
 } break; } return str;
}

